import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;


public class XTests {
    /**This computes log(max-min) where max is 
       the maximum of the flag invariants and
       min is the minimum.  It converges to
       -infty as the polygon becomes projectively
       regular.*/

    public static double logVariance(PolyVector V) {
	double[] d=XInvariants.invariant(V);
	double r=range(d);
	return(Math.log(r));
    }


    public static double minimax(int k,PolyVector V) {
	double[] d=XInvariants.invariant(V);
	double min=1;
	int n=d.length;
	double[] e=new double[k];
	for(int i=0;i<n;++i) {
	    for(int j=0;j<k;++j) {
		e[j]=d[(i+j)%n];
	    }
	    double test=max(e);
	    if(min>test) min=test;
	}
	return(min);
    }




    public static double range(double[] d) {
	double min=min(d);
	double max=max(d);
	return(max-min);
    }

    public static double min(double[] d) {
	double min=100000;
	for(int i=0;i<d.length;++i) {
	    if(min>d[i]) min=d[i];
	}
	return(min);
    }

    public static double max(double[] d) {
	double max=-100000;
	for(int i=0;i<d.length;++i) {
	    if(max<d[i]) max=d[i];
	}
	return(max);
    }

}


