import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class GraphicsHelp {


    public static Path2D.Double getImage(int[] a,PolyVector Q,int mesh) { 
	Path2D.Double gp=new Path2D.Double();
	PolyVector P=Q.shrink(.00000001);
	boolean use=false;
	double[] d1={0,0};
	double[] d2={0,0};
	int count=0;
	  for(int i=0;i<P.count;++i) {
	      for(int j=0;j<mesh;++j) {
		  d1=P.getPoint(i,j,mesh);
		  d1=HeatSemigroup.main(a,d1);
		  if(count==0) gp.moveTo((float)(d1[0]),(float)(d1[1]));
		  if(count>0) {
		      double test=Math.abs(d1[0]-d2[0])+Math.abs(d1[1]-d2[1]);
		      if(test<200) gp.lineTo((float)(d1[0]),(float)(d1[1]));
		      if(test>=200)  gp.moveTo((float)(d1[0]),(float)(d1[1]));
		  }
		  d2[0]=d1[0];
		  d2[1]=d1[1];
		  ++count;
	      }
	  }
	  gp.closePath();
	  return(gp);
    }

    public static void drawMap(PictureCanvas P,Graphics2D g,int[] a,PolyVector Q,int mesh,Color C,int thick) { 
	Path2D.Double gp=new Path2D.Double();
	gp=getImage(a,Q,mesh);
	g.setStroke(new BasicStroke(thick));
	gp=P.transform(gp);
	g.setColor(C);
	g.draw(gp);
  	g.setStroke(new BasicStroke(1));
    }

    public static void fillMap(PictureCanvas P,Graphics2D g,int[] a,PolyVector Q,int mesh,Color C,int thick) { 
	Path2D.Double gp=getImage(a,Q,mesh);
	g.setStroke(new BasicStroke(thick));
	gp=P.transform(gp);
	g.setColor(C);
	g.fill(gp);
	g.setColor(Color.black);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }


    /**converts a polygonal generalpath into a polygon*/

    public static Complex[] fromPath(Path2D.Double X) {
	Complex[] Y=new Complex[12];
	AffineTransform A=AffineTransform.getTranslateInstance(0,0);
	PathIterator P=X.getPathIterator(A);
	double[] coords=new double[6];
	int count=0;
	Complex HISTORY=new Complex(-9999,-9999);
	Complex CURRENT=new Complex();
	while(P.isDone()==false) {
	    P.currentSegment(coords);
	    CURRENT=new Complex(coords[0],coords[1]);
	    if(Complex.dist(CURRENT,HISTORY)>.00000001) {
	        Y[count]=new Complex(CURRENT);
		++count;
		HISTORY=new Complex(CURRENT);
	    }
	    P.next();
	}
	return(Y);
    }


    public static void label(Graphics2D g,Path2D.Double gp,int N) {
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	Complex[] Z=GraphicsHelp.fromPath(gp);
	for(int i=0;i<N;++i) {
	    Integer I=new Integer(i+1);
	    try{
	    g.drawString(I.toString(),(int)(Z[i].x),(int)(Z[i].y));
	    }
	    catch(Exception e) {}
	}
    }

    public static String clean(double d) {
	Double D=new Double(d);
	String S=D.toString();
	int m=S.length();
	if(m>18) m=18;
	S=S.substring(0,m-1);
	return(S);
    }

    public static String cleanLong(double d) {
	Double D=new Double(d);
	String S=D.toString();
	return(S);
    }

}
