import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



/**This class decides how a click with the
   keys 1,2,3,... is approximated by elements
   of the ring containing the vertices of the
   partition.*/

public class HandleApproximation {
    int X,Y; //location of control panel 
    Lever MODE;
    Lever COERCE;
    ListenSquare INFO;
    SelectIntegerKeyboard[] N=new SelectIntegerKeyboard[4];

    public HandleApproximation(int x,int y) {
	X=x;
	Y=y;
	COERCE=new Lever(X+60,Y+18,2,4);
	MODE=new Lever(X+3,Y+18,0,2);
	for(int i=0;i<4;++i) {
	    N[i]=new SelectIntegerKeyboard(X+60+50*i,Y+10,45,15,0);
	}
	INFO=new ListenSquare(X+268,Y,12,12);
    }

    public void render(Graphics2D g) {
        g.setColor(new Color(70,0,70));
	g.fillRect(X,Y,280,30);
	g.setColor(Color.white);
	g.drawRect(X,Y,280,30); 
	INFO.infoRender(g);
        MODE.render2(g,"mode",Color.blue); 
 	if(MODE.val==0) {
             COERCE.render2(g,"approx",Color.blue); 
	     g.drawString("approximation control",X+130,Y+20);
	}
	if(MODE.val==1) {
	  for(int i=0;i<4;++i) {
	     N[i].render(g,new Color(0,0,100),Color.blue,Color.white,Color.white);
	  }
	}
    }



    public int process(Point X) {
	if(MODE.val==0) COERCE.process(X);
	if(MODE.val==1) {
	    int index=-1;
	    for(int i=0;i<4;++i) {
		if(N[i].inside(X)==1) index=i;
	    }
	    if(index!=-1) {
		for(int i=0;i<4;++i) N[i].on=0;
		N[index].on=1;
	    }
	}
	MODE.process(X);
	if(INFO.inside(X)==1) return(99);
	return(0);

    }
 
    public void keyProcess(KeyEvent e) {
	for(int i=0;i<4;++i) {
	    if(N[i].on==1) N[i].modify(e);
	}
    }


}
