import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



/**This class lets you select the bound for the
   determinant tester*/

public class HandleTestArea {
    int X,Y; //location of control panel 
    ListenSquare I; //documentation
    SelectInteger[] S=new SelectInteger[2];
    ListenSquare NEGATE;
    int mode=0;

    public HandleTestArea(int x,int y) {
	X=x;
	Y=y;
	S[0]=new SelectInteger(X+5,Y+40,30,15,0,-500,500,1);
	S[1]=new SelectInteger(X+85,Y+40,30,15,0,-500,500,1);
	I=new ListenSquare(X+83,Y,12,12);
	NEGATE=new ListenSquare(X+5,Y+88,20,20);
    }

    public void render(Graphics2D g) {
	g.setColor(new Color(100,0,100));
	int size=125;
	g.fillRect(X,Y,200,113);
	g.setColor(Color.white);
	g.drawRect(X,Y,200,113);
	for(int i=0;i<2;++i) S[i].render(g,Color.red,Color.white,Color.white);
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.drawString("Test if (+/-) det(dF)>",X+5,Y+25);
	g.drawString("+",X+70,Y+50);
	g.drawString("\u03D5",X+140,Y+50);
	NEGATE.render(g,Color.blue);
	g.drawString("negate bound",X+35,Y+104);
	Double d=new Double(convert(S[0].val,S[1].val));
	g.drawString(d.toString(),X+5,Y+80);
    }

    public int process(Point X) {
	if(I.inside(X)==1) return(99);
	for(int i=0;i<2;++i) S[i].modify(X);
	if(NEGATE.inside(X)==1) {
	    S[0].val=-S[0].val;
	    S[1].val=-S[1].val;
	}
	return(0);
    }
    public QI2 getBound() {
	QI2 b=new QI2(S[0].val,S[1].val);
	return(b);
    }

    public static double convert(int a,int b) {
	double phi=(Math.sqrt(5)+1)/2;
	return(a+b*phi);
    }

}
