import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;


public class PolyVector {
    Vector[] V=new Vector[100];
    int count;              //number of sides
    int name;               //number of polygon in our data list
    int[] tag;              //list of point names
    int[] image=new int[4]; //group element choice
    int age;

    public PolyVector() {
	for(int i=0;i<99;++i) 
	V[i]=new Vector();
    }


    public PolyVector(Vector A,Vector B,Vector C) {
	this.count=3;
	this.V[0]=new Vector(A);
	this.V[1]=new Vector(B);
	this.V[2]=new Vector(C);
    }

    public PolyVector(PolyVector Q) {
	this.count=Q.count;
	for(int i=0;i<Q.count;++i) this.V[i]=Q.V[i];
    }

    public PolyVector normalize() {
	PolyVector P=new PolyVector();
	P.count=count;
	for(int i=0;i<count;++i) {
	    P.V[i]=V[i].normalize();
	}
	return(P);
    }

    public PolyVector shrink(double d) {
	PolyVector Q=new PolyVector();
	Q.count=this.count*2;
	Q=Q.normalize();
	double[] W=Q.center();
	for(int i=0;i<count;++i) {
	    int j=(i+1)%count;
	    for(int q=0;q<2;++q) {
		Q.V[2*i+0].x[q]=(1-d)*V[i].x[q]+d*V[j].x[q];
		Q.V[2*i+1].x[q]=(1-d)*V[j].x[q]+d*V[i].x[q];
	    }
	    Q.V[2*i+0].x[2]=1;
	    Q.V[2*i+1].x[2]=1;
	}
	return(Q);
    }




    public Path2D.Double toPath() {
	PolyVector P=this.normalize();
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(P.V[0].x[0],P.V[0].x[1]);
	for(int i=0;i<count;++i) {
	   gp.lineTo(P.V[i].x[0],P.V[i].x[1]);
	}
	gp.closePath();
	return(gp);
    }

    public static Path2D.Double toPath(PolyVector Q1,PolyVector Q2) {
	PolyVector P1=Q1.normalize();
	PolyVector P2=Q2.normalize();
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<P1.count;++i) {
	    gp.moveTo(P1.V[i].x[0],P1.V[i].x[1]);
	    gp.lineTo(P2.V[i].x[0],P2.V[i].x[1]);
	}
	return(gp);
    }



    /**subdivide into triangles*/

    public PolyVector[] toSubdivision() {
	PolyVector[] LIST=new PolyVector[count-2];
	for(int i=0;i<count-2;++i) {
	    LIST[i]=new PolyVector(V[0],V[i+1],V[i+2]);
	}
	return(LIST);
    }


    public void print() {
	for(int i=0;i<count;++i) V[i].print();
    }

    public double[] getPoint(int i,int j,int k) {
	int i0=i;
	int i1=(i+1)%count;
	double[] a={V[i0].x[0]/V[i0].x[2],V[i0].x[1]/V[i0].x[2]};
	double[] b={V[i1].x[0]/V[i1].x[2],V[i1].x[1]/V[i1].x[2]};
	double t=1.0*j/k;
	double[] c=new double[2];
	for(int q=0;q<2;++q) c[q]=(1-t)*a[q]+t*b[q];
	return(c);
    }


    /**gets a length n random list whose sum is 1.*/

    public static double[] randomList(int n) {
	double[] d=new double[n];
	double tot=0;
	for(int i=0;i<n;++i) {
	    d[i]=Math.random();
	    tot=tot+d[i];
	}
	for(int i=0;i<n;++i) d[i]=d[i]/tot;
	return(d);
    }


    /**returns a random point in the convex hull of a polygon.*/

    public static double[] random(PolyVector P) {
	int n=P.count;
	double[] d=randomList(n);
	double x=0;
	double y=0;
	for(int i=0;i<n;++i) {
	    x=x+d[i]*P.V[i].x[0]/P.V[i].x[2];
	    y=y+d[i]*P.V[i].x[1]/P.V[i].x[2];
	}
	double[] z={x,y};
	return(z);
    }

    public double[] center() {
	int n=this.count;
	double d=1.0/n;
	double x=0;
	double y=0;
	for(int i=0;i<n;++i) {
	    x=x+d*V[i].x[0];
	    y=y+d*V[i].x[1];
	}
	double[] z={x,y};
	return(z);
    }

    /**This produces a point interior to the polygon,
       just using the first 3 vertices */

    public double[] cheapInterior() {
	double d=1.0/3;
	double x=0;
	double y=0;
	for(int i=0;i<3;++i) {
	    x=x+d*V[i].x[0];
	    y=y+d*V[i].x[1];
	}
	double[] z={x,y};
	return(z);
    }

    /**assumes the polygon is normalized.*/

    public int nearest(Complex z) {
	Vector W=new Vector(z.x,z.y,1);
	int index=-1;
	double dist=100000;
	for(int i=0;i<this.count;++i) {
	    double test=Vector.dist(W,V[i]);
	    if(dist>test) {
		dist=test;
		index=i;
	    }
	}
	return(index);
    }


}

