
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PopupManager {
    Manager M;
    int X,Y;
    ListenSquare INFO,TUTOR,FORMULAS,PLOT,SELECT,COORD,TILE,TESTS,DEBUG;

    public PopupManager(Manager m,int x,int y) {
	M=m;
	this.X=x;
	this.Y=y;
	INFO=new ListenSquare(X,Y,80,20);
	FORMULAS=new ListenSquare(X,Y+40,80,20);
	TUTOR=new ListenSquare(X,Y+20,80,20);
	PLOT=new ListenSquare(X,Y+60,80,20);
	SELECT=new ListenSquare(X,Y+80,80,20);
	COORD=new ListenSquare(X,Y+100,80,20);
	TILE=new ListenSquare(X,Y+120,80,20);
	TESTS=new ListenSquare(X,Y+140,80,20);
	DEBUG=new ListenSquare(X,Y+160,80,20);
    }


    public void render(Graphics2D g) {
	g.setColor(Color.black);
	g.fillRect(X,Y,80,180);
	g.setColor(Color.white);
	g.drawRect(X,Y,80,180);
	INFO.render(g,new Color(0,60,60));
	TUTOR.render(g,new Color(0,90,90));
	FORMULAS.render(g,new Color(0,0,255));
	PLOT.render(g,new Color(80,100,120));
	SELECT.render(g,new Color(100,0,100));
	COORD.render(g,new Color(100,0,100));
	TILE.render(g,new Color(120,120,120));
	TESTS.render(g,new Color(50,100,255));
	DEBUG.render(g,new Color(80,80,80));
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,13));
	g.drawString("instructions",X+5,Y+15);
	g.drawString("formulas",X+5,Y+55);
	g.drawString("tutorial",X+5,Y+35);
	g.drawString("plot details",X+5,Y+75);
	g.drawString("poly select",X+5,Y+95);
	g.drawString("poly coords",X+5,Y+115);
	g.drawString("partition",X+5,Y+135);
	g.drawString("tests",X+5,Y+155);
	g.drawString("debugger",X+5,Y+175);
    }

    public void process(Point X) {


	if(INFO.inside(X)==1) {
	    PopupDocumentCanvas PD=new PopupDocumentCanvas();
	    PD.D.M=this.M;
	    M.D=PD.D;
	}

	if(TUTOR.inside(X)==1) {
	    PopupProofCanvas PPR=new PopupProofCanvas();
	    PPR.PR.M=this.M;
	    M.PR=PPR.PR;
	}

	if(FORMULAS.inside(X)==1) {
	    PopupFormulaCanvas PF=new PopupFormulaCanvas();
	    PF.F.M=this.M;
	    M.F=PF.F;

	}

	if(PLOT.inside(X)==1) {
	    PopupStyleCanvas PK=new PopupStyleCanvas();
	    PK.K.M=this.M;
	    M.K=PK.K;
	}

	if(SELECT.inside(X)==1) {
	    PopupSelectCanvas PS=new PopupSelectCanvas();
	    PS.S.M=this.M;
	    M.S=PS.S;
	}

	if(COORD.inside(X)==1) {
	    PopupCoordCanvas PCC=new PopupCoordCanvas();
	    PCC.CC.M=this.M;
	    M.CC=PCC.CC;
	}

	if(TILE.inside(X)==1) {
	    PopupTileCanvas PT=new PopupTileCanvas();
	    PT.T.M=this.M;
	    M.T=PT.T;
	}

	if(DEBUG.inside(X)==1) {
	    PopupDebugCanvas PDB=new PopupDebugCanvas();
	    PDB.DB.M=this.M;
	    M.DB=PDB.DB;
	}

	if(TESTS.inside(X)==1) {
	    PopupTestCanvas PTC=new PopupTestCanvas();
	    PTC.TC.M=this.M;
	    M.TC=PTC.TC;
	}


    }



}

