import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.*;


public class DocumentProof {

    public DocumentProof() {}


    public static void main(Manager M) {
        String S="proof documenter";

	S=S+"\n\nThis console takes you through an outline of the overall proof, showing you how the various tests you perform are translated into geometric and dynamical statements about the map.";

	S=S+"\n\nThe proof comes in 5 parts. When you click on the boxes of the control panel you bring up an auxiliary set of arrow keys.  When you click on these arrow key, you go through the steps of the proof for that part..";

	S=S+"\n\nThe account here is somewhat short on traditional mathematics.  I intend to write a paper which has the argument written in more detail, and in a more traditional way.";

	try {
        M.D.setExplain(S);
        M.D.repaint();
	}
	catch(Exception e) {}
    }

    public static void doStep(int a,int b,Manager M) {
	String[] T={"outline","Gauss","Cantor","middle","Anosov","algebra"};
	Integer B=new Integer(b);
	String S="proof: "+ T[a-1]+" part "+B.toString();
	S=S+"\n\n";

	if((a==1)&&(b==1)) S=S+go11(M);
	if((a==1)&&(b==2)) S=S+go12(M);
	if((a==1)&&(b==3)) S=S+go13(M);
	if((a==1)&&(b==4)) S=S+go14(M);
	if((a==1)&&(b==5)) S=S+go15(M);
	if((a==1)&&(b==6)) S=S+go16(M);
	if((a==1)&&(b==7)) S=S+go17(M);
	if((a==3)&&(b==1)) S=S+DocumentProofCantor.go31(M);
	if((a==3)&&(b==2)) S=S+DocumentProofCantor.go32(M);
	if((a==3)&&(b==3)) S=S+DocumentProofCantor.go33(M);
	if((a==3)&&(b==4)) S=S+DocumentProofCantor.go34(M);
	if((a==3)&&(b==5)) S=S+DocumentProofCantor.go35(M);
	if((a==3)&&(b==6)) S=S+DocumentProofCantor.go36(M);
	if((a==3)&&(b==7)) S=S+DocumentProofCantor.go37(M);
	if((a==3)&&(b==8)) S=S+DocumentProofCantor.go38(M);
	if((a==3)&&(b==9)) S=S+DocumentProofCantor.go39(M);
	if((a==4)&&(b==1)) S=S+DocumentProofMiddle.go41(M);
	if((a==4)&&(b==2)) S=S+DocumentProofMiddle.go42(M);
	if((a==4)&&(b==3)) S=S+DocumentProofMiddle.go43(M);
	if((a==4)&&(b==4)) S=S+DocumentProofMiddle.go44(M);
	if((a==4)&&(b==5)) S=S+DocumentProofMiddle.go45(M);
	if((a==4)&&(b==6)) S=S+DocumentProofMiddle.go46(M);
	if((a==4)&&(b==7)) S=S+DocumentProofMiddle.go47(M);
	if((a==5)&&(b==1)) S=S+DocumentProofAnosov.go51(M);
	if((a==5)&&(b==2)) S=S+DocumentProofAnosov.go52(M);
	if((a==5)&&(b==3)) S=S+DocumentProofAnosov.go53(M);
	if((a==6)&&(b==1)) S=S+DocumentProofAlgebra.go61(M);
	if((a==6)&&(b==2)) S=S+DocumentProofAlgebra.go62(M);
	if((a==6)&&(b==3)) S=S+DocumentProofAlgebra.go63(M);
	if((a==6)&&(b==4)) S=S+DocumentProofAlgebra.go64(M);
	if((a==6)&&(b==5)) S=S+DocumentProofAlgebra.go65(M);
	if((a==6)&&(b==6)) S=S+DocumentProofAlgebra.go66(M);
	if((a==6)&&(b==7)) S=S+DocumentProofAlgebra.go67(M);
	if((a==6)&&(b==8)) S=S+DocumentProofAlgebra.go68(M);

	try{
          M.D.setExplain(S);
          M.D.repaint();
	}
	catch(Exception e) {}
    }


    public static String go11(Manager M) {
	int[] a={0,0,0,1,0,0,0,0};
	setDisplay(M,a);
        M.C.TC.FILL.val=0; 
        M.P.setScales(150,400,50); 
        SpecialAffine.GO=false;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=1;

	String S="(Goal) If you read the introductory text to this program, you will know about the heat semigroup and its associated Julia set J, consisting of points which are never mapped into the set points representing convex pentagon.  Say that a Cantor lamination is the product of an interval and a Cantor set.";

	S=S+"The overall goal of the argument is to show that J has the following structure.";

	S=S+"\n\n1. J contains an invariant Cantor set JC of area 0.";

	S=S+"\n\n2. Every point of J-JC eventually maps into a forward invariant Cantor lamination JA of area 0;";

S=S+"\n\nThe first two claims imply that J is contained in a union of a Cantor set and a countable union of preimages of the Cantor lamination under a rational map.  This implies that J has area 0. There are other consequences of the structure we can establish by the same methods. For instance, J is connected.  Once the existence and basic properties of JA and JC are established, this further result is proved by looking at the preimages of JA under the map.  However, we will not go into this part of the proof.";

	return(S);
    }


    public static String go12(Manager M) {
	int[] a={1,0,0,1,0,0,0,0};
	setDisplay(M,a);
        M.P.setScales(150,500,25); 
        SpecialAffine.GO=false;	
        M.C.TC.FILL.val=0; 
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=1;

	String S="(Gauss) The first idea in the proof is to exploit the 10-fold birational symmetry of the Gauss group.  The blue triangle \u03A9 shown turns out to be a fundamental domain for the Gauss group:  Every orbit intersects \u03A9.  So, to understand the structure of the Julia set J, we really just need to understand the portion of J contained inside \u03A9.";

	S=S+Documentation.gaussAction();

	return(S);
    }



    public static String go13(Manager M) {
	int[] a={1,0,0,0,1,1,1,1};
	setDisplay(M,a);
        M.P.setScales(150,500,25); 
        SpecialAffine.GO=false;	
        M.C.TC.FILL.val=0; 

	String S="(Tiling) We tile \u03A9 with small polygons and associate to each polygon in the tiling (a PIECE) one of the PRIMARY elements of the heat semigroup.  The primary elements have the form gF where g is in the Gauss group and F is the projective heat map itself.  So, piece gets one of 10 primary associated to it.  In each case, we are able to control the image of the given piece under the associated primary map to the extent that it allows us to deduce the final structural results.";

	S=S+"\n\nYou can see the tiling on the screen.  We have also included some auxiliary tiles not in \u02A9 because we will need to the images of these pieces under the relevant maps.  If you click on a piece you can see the image of its boundary plotted in green.";

	return(S);
    }





    public static String go14(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	setDisplay(M,a);
        M.P.setScales(350,330,90);
	M.C.TC.FILL.val=1; 
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=1;
	M.C.TC.setPiece(16,M);

	String S="(Cantor) We first focus on the region K shown in white on the screen.  K is a Gauss-group invariant union of 10 curvilinear quadrilaterals.  The portion of K inside the fundamental domain \u03A9 is an ordinary quadrilateral. Note that K \u2229 \u03A9 is partitioned into 9 polygons.  Let M0 denote the union of the magenta and orange pieces.";

	S=S+"\n\nLet K0=K. Let GMO be the orbit of MO under the Gauss group G.  Analyzing the images of the 9 tiles in K \u2229 \u03A9, and using Gauss symmetry, we deduce that every point of K0-GMO is ejected from K1 by every primary map, and that GMO is a union of 6 polygonal disks.  The screen is set to show one of the (normally) cyan pieces ejected from K by the associated primary map.  This piece is colored yellow and the image (of the boundary of the piece) under the map is shown in green.";

	S=S+"\n\nWe further deduce each component of GMO has a subdisk which is mapped homeomorphically by each primary map onto K0, and that all other points in GMO are ejected from K0.  This allows us to define 6 inverse branches of the primary maps.  The domain for these inverse branches is K0.  Each such inverse carries K0 homeomorphically into a component of GMO. We let K1 be the subset of GMO consisting of these images disks.";

S=S+"\n\nWe now define K2 to be the union of the images of K1 under our inverse branches. The set K2 consists of 6x6 pairwise disjoint disks.  We then define K3, which consists of 6x6x6 pairwise disjoint disks. And so on.";

S=S+"\n\nThe sets K1, K2, K3,... are nested. Let JC be their intersection. Using information about the differentials of the primary maps on the magenta pieces in the partition, we deduce that each inverse branch contracts distances and also contracts areas by a factor greater than 6.  From this we deduce that JC is a Cantor set of zero area.  Every point of K0-JC is ejected from K0 by some element of the heat semigroup.";

	return(S);
    }



    public static String go15(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	setDisplay(M,a);
        M.P.setScales(150,500,25); 
	M.C.TC.FILL.val=1; 
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=1;
	M.C.TC.setPiece(18,M);

	String S="(Middle) Let K be the set discussed in the previous step. Let L be the union of the 8 light red pieces of the partition.  L is the set which contains the attractor.  Let p be a point of \u03A9-K.  We show that either some element of the heat semigroup maps p into the set C of points corresponding to convex pentagons or some element of the heat semigroup maps p into the set L. The dichotomy works like this:";

	S=S+"\n\nThe blue pieces map into C.";
	S=S+"\n\nThe auxiliary red pieces map into C.";

	S=S+"\n\nThe green pieces map (after at most 3 iterates of the relevant primary maps) into the union of the blue pieces, the auxiliary dark red pieces, and L.  The screen shows this for the (normally) green piece 18.  You can click around on the other pieces and see the images under the associated primary map.";
	S=S+"\n\nThe purple pieces map over themselves in an expanding way.  So, every point of a purple piece, except the vertex contained in K, is eventually mapped outside the purple piece, and also outside of K. This reduces the case of points in the purple pieces to already handled cases.";

	return(S);
    }


    public static String go16(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	setDisplay(M,a);
        M.P.setScales(-180,500,60); 
	M.C.TC.FILL.val=0; 
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=0;
	M.C.CORE.L[2].on=0;
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(8,M);

	String S="(Anosov) Let L be the union of the 8 light red pieces of the partition. L is the set which contains the attractor JA.  Let M denote the union of the blue pieces and the single dark red piece beneath the big blue triangle.  All the points in M eventually map into the set C of convex points.";

	S=S+"\n\nWe show that each piece of L maps into L \u222A M.  Moreover, we check that throughout L, the acute cone-field in the tangent space, defined by the vectors (2,1) and (0,1), is mapped into itself in an expansive way.  This is the classic setup for Anosov dynamics.  We deduce that every point of L is eventually mapped into an area zero set JA which has the form (Cantor set)X(interval).";

	S=S+"\n\n Putting together our results, we see that every point of \u03A9-JC either maps into the set C of convex points or into JA.  Hence, every point of J-JC maps into JA by some element of the heat semigroup. This implies that J-JC is covered by a countable union of pre-images of JA and hence has area 0.  Since JC also has area 0, we see that J has area 0.";

	S=S+"\n\nLooking carefully at the way in which L is mapped over itself, with the bottom 4 pieces mapping to the right and the top 4 pieces mapping to the left, we will see that JA has a dense orbit.";
	return(S);
    }


    public static String go17(Manager M) {
	int[] a={1,0,0,1,1,1};
	setDisplay(M,a);
        M.P.setScales(-180,500,60); 
	M.C.TC.FILL.val=0; 
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=0;
	M.C.CORE.L[2].on=0;
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(8,M);

	String S="(sing) By analyzing the differential of the heat map at various places, we will establish two further results:";

	S=S+"\n\nOutside of a countable union of algebraic curves (a 1-dimensional set) the set J-JC is a Cantor lamination.";

	S=S+"\n\nIn the region x>1 and x>y and x \u2260 y, the set J is a Cantor lamination.  This gives a fairly large neighborhood of JA in which J is a Cantor Lamination.";
	return(S);
    }





    public static void setDisplay(Manager M,int[] a) { 
        SpecialAffine.GO=false;
	for(int i=0;i<6;++i) M.C.DISPLAY.L[i].on=a[i];
    }



}
