


public class DocumentProofCantor {


    public static String go31(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,90);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(16,M);
	int[] t={16,22,29};
	M.setPieces(t);


	String S="Here we give a more detailed account of the Cantor set step in the proof. Recall that K is the set of 10 curvilinear quadrilaterals. We want to prove that K contains an invariant Cantor set JC of zero area such that every point of K-JC is ejected from K by some element of the heat semigroup.";

	S=S+"\n\nThe intersection K\u2229\u03A9 is tiled by 9 pieces: 3 cyan, 2 orange, and 4 magenta.";

	 S=S+"\n\n(P1) Each cyan piece is carried outside K by its associated primary map.";

	 S=S+"\n\nYou see the image of (the boundary of) the highlighted cyan piece plotted in green.  It appears to the left of the set K.  You can click on the other cyan pieces and see that something similar happens. Alternatively, you can use the row of squares at the bottom of the proof console to select these pieces.  In the algebra section, we will explain how we rigorously establish this fact with integer calculations.";

	return(S);
    }



    public static String go32(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,90);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(33,M);
	int[] t={0,1,2,3,39,33};
	M.setPieces(t);


	String S="(P2) Every point in an orange piece is carried outsde piece is carried outside K either by a primary map or by the square of a primary map.";


	S=S+"\n\nThis is a bit trickier to see.  Let P be one of the orange pieces.  Let MO be the union of the magenta and orange pieces.  Let F be any of the 10 primary maps.  We show that F(P) is disjoint from MO. (You can see thisnumerically by selecting each of the 10 primary maps and looking at the green image.) This means that the only points of P not carried outside K are mapped into the cyan tiles or their images under the Gauss group. As we have seen in (A), such points are carried outside K by the primary maps.";

	return(S);
    }



    public static String go33(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,90);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(4,M);
	M.piecesOff();


	String S="(P3) The highlighted purple triangle P is mapped outside K by the associated primary map F, except for the vertex it shares with J.  This vertex is fixed by F.";

	S=S+"\n\nThe program shows the image F(P) in green.  F(P) is contained in the cone defined by the fixed vertex of P and the two incident sides of P.";

	return(S);
    }


    public static String go34(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,130);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(0,M);	
        int[] t={0,1,2,3,39,33};
	M.setPieces(t);


	String S="Let D0=K. Recall that MO is the union of the magenta and orange pieces in K.  Using the description of the action of the Gauss group G on the fundamental domain \u03A9, we see that the orbit GMO of MO under the Gauss group is a union of 6 pairwise disjoint polygonal subdisks of D0.  Using properties (P1) and (P3), we see that the boundary of each of these disks is mapped outside of K0. The point is that these boundaries are also boundaries of the cyan pieces and the purple piece already considered. We also check, rather trivially, that each piece of MO has a point which is mapped inside K0. So, each component of GMO has a point which is mapped inside K0.";

S=S+"\n\nNow, let P be any piece of MO and let F be the associated primary map.  We check";

 	S=S+"\n\n(P4) The denominators of the coordinate functions of F do not blow up in the interior of P";

         S=S+"\n\n(P5) The determinant det(dF) does not vanish in the interior of P.";

	 S=S+"\n\nProperties (P4) and (P5) imply that each primary map F is a local homeomorphism when restricted to each connected component D of GMO.  With a little more work, we show that F is an embedding when restricted to each of the 6 disks.  We outline this argument in the next 2 stepw.";

	return(S);
    }


    public static String go35(Manager M) {
	int[] a={1,0,1,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,130);
	M.C.TC.FILL.val=0; 
	M.C.TC.setPiece(33,M);	
        int[] t={0,1,2,3,39,33};
	M.setPieces(t);
	M.C.TEST.forceMode(6);
	M.C.HTC.forceCone2();
	M.C.TESTCHOICE.turnOn();

	String S="The embedding argument has two halves.  One half is for the disk made from piece 0.  Call this disk D10.  To save words, we let P0 stand for piece 0.  So, D10 is the orbit of P0 under the Gauss group.  The other half if the disk D11 made from the remaining 5 pieces.  We will deal with D11 first.";

	S=S+"\n\nConsider D11 first. D11 consists of two halves, LD11, the lower portion below the diagonal and the upper portion, UD11, above the diagonal.  Let F be the primary element (1,1,1).  We check the following things for the 5 pieces comprising LD11:";

	 S=S+"\n\ndF(0,1) and dF(1,2) satisfy X<0.  Hence, this holds for vectors in the positive cone determined by these vectors";
	 S=S+"\n\ndF(1,2) and dF(1,-4) satisfy Y>0.  Hence, this holds for vectors in the positive cone determined by these vectors"; 
	 S=S+"\n\ndF(1,-4) and dF(0,1) satisfy X+4Y>0. Hence, this holds for vectors in the positive cone determined by these vectors.";

	 S=S+"\n\nThe union of the three cones above is a halfplane.  Hence, any unoriented line through the origin points into one of these cones, either forwards or backwards. Hence, the restriction of F to any straight line segment in LD11 is an embedding.  Hence, the restriction of F to LD11 is an embedding.  But then the restriction of F to D11 is an embedding because F commutes with the Gauss group.";

	 S=S+"\n\nThe embedding result for other 4 subdisks in the Gauss orbit of D11 follows from symmetry.";

	 S=S+"\n\nWe have set things up so that if you press 'go', you can make the above tests for all the pieces at once.";

	return(S);
    }

    public static String go36(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,130);
	M.C.TC.FILL.val=0; 
	M.C.TC.setPiece(0,M);	
	M.C.TEST.forceMode(6);
	M.C.HTC.forceCone3();
	M.C.TESTCHOICE.turnOn();
	for(int i=2;i<6;++i) M.C.TESTCHOICE.on[i]=0;


	String S="Consider D00, the gauss orbit of P0.  By symmetry it suffices to prove that the same map F, map(1,1,1), is an embedding on P0.  Two of the sides of P0 are segments in the boundary of the fundamental domain for the Gauss group.  Call these the special sides. It follows from symmetry that the map F carries the union of the special sides into themselves.  The top special side is mapped into the line through the bottom special side, and the bottom special side is mapped into the line through the top special side.  The third side e of P0 lies in the acute cone defined  by the vectors (2,-1) and (0,-1).  We check the following:";

	     S=S+"\n\ndF(2,-1) and dF(0,-1) satisfy Y>0.  Hence, this holds for vectors in the positive cone determined by these vectors.  In particular dF(e) has the property at all points in P0.";

	 S=S+"\n\nThis means that F(e) must travel up from the bottom special side to the top special side in am embedded way.  Hence F(P0) has embedded boundary.  Since F is a local homeomorphism on P0 and F(P0) has an embedded boundary, F(P0) is a global homeomorphism on P0.";

	 S=S+"\n\nWe have set things up so that if you press 'go', you can make the above tests for P0.";

	return(S);
    }


    public static String go37(Manager M) {
	int[] a={1,0,0,1,1,1,1,1};
	DocumentProof.setDisplay(M,a);
	M.C.CORE.L[0].on=0;
	M.C.CORE.L[1].on=1;
	M.C.CORE.L[2].on=0;
        M.P.setScales(350,350,130);
	M.C.TC.FILL.val=1; 
	M.C.TC.setPiece(0,M);
	try{M.PR.HP.SHOWPIECE=false;}
	catch(Exception e) {}


	String S="Combining the previous steps, we see that K0 contains a union K1 of 6 subdisks, and the restriction of a primary element to any subdisk is an embedding. Using this structure, we define 6 inverse branches of the primary maps. Each branch carries K0 homeomorphically onto a component of K1.  Notice that these branches are not unique. If b is some branch which carries K0 to some component D of K1, then so does the map bg, where g is any element of the Gauss group.  This non-uniqueness does not effect our argument below: all the results are independent of the choices.";

	S=S+"\n\nWe define K2 to be the union of all images of K1 under all 6 branches.  By construction K2 consists of 6x6 pairwise disjoint disks, 6 per component of K1.  Next we define K3 to be the union of all images of K2 under all 6 branches.  And so on.  Let JC be the nested intersection of these sets.  By construction JC is invariant under the heat semigroup and every point of K0-JC is ejected from K by some element of the heat semigroup.";

	return(S);
    }


    public static String go38(Manager M) {
	M.piecesOff();
	String S="We establish the following area estimate:";

	S=S+"\n\n(P6) Let P be any piece of MO and let F be the associated primary map. Then |det dF|>7 on the interior of P. (This is not close to the sharp bound. The main point is that this bound exceeds 6.)";

	S=S+"\n\nIt would be nice to conclude, by symmetry, that every primary element expands area by a factor of at least 7 on each component of K1.  However, since the Gauss group is not area preserving, this does not follow from any kind of symmetry.  To get around this problem, we put a Gauss-invariant Riemannian metric on K0 which agrees with the Euclidean metric inside K1.  With respect to this metric, every primary map expands area by a factor of at least 7 on every component of K1.   But then K(n+1) has at most 6/7 times the Riemannian area as K(n) for all n.  Hence JC has Riemannian area 0.  But then JC has Lebesgue area 0 as well.";


	return(S);
    }



    public static String go39(Manager M) {
	M.piecesOff();
	String S="We establish the following metrical estimate:";

	S=S+"\n\n(P6) Let P be any magenta piece and let F be the associated primary map.  On P, the maximum L2 norm of |dF|, is less than the global minimum of |det dF|.  Hence F is an expanding map on P. (The L2 norm of a matrix is the square root of the sum of the squares of its entries.)";

	S=S+"\n\nWe tried to prove a similar estimate for the orange pieces, but we couldn't do it.  However, we recall property (P2): Every point of an orange piece is ejected from K0 either by a primary map or the second iterate of a primary map. Hence, the set JC is disjoint from the orange pieces.";

	S=S+"\n\n Let L1,L2,L3,... be the result of removing any point from K1,K2,K3 which is mapped into an orange piece by some element of the heat semigroup. By construction L(n) is a subset of K(n), consisting of a finite union of topological disks.  From (P6) we can construct a Gauss-invariant Riemannian metric on K0 such that each primary maps are all expanding on each component of L(n) for any n.  But then the maximum diameter of a component of L(n) tends to 0 as n tends to infinity.  This shows that JC is a Cantor set.";

	S=S+"\n\nIn summary, the big region K=K0 contains a Gauss-invariant Cantor set JC of area 0 such that every point of K-JC is ejected from K by some element of the heat semigroup.";

	return(S);
    }






}
