import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This is our class for members of Z[phi]*/

public class QI2Polygon {
    QI2[][] V=new QI2[20][2];
    int COUNT;
    int age;
    boolean survey;
    int testnumber;
    int color;

    /**These are the construction methods*/

    public QI2Polygon() {
	survey=false;
    }

    /**A triangle*/

    public QI2Polygon(QI2[] A,QI2[] B,QI2[] C) {
	for(int i=0;i<2;++i) {
	  V[0][i]=new QI2(A[i]);
	  V[1][i]=new QI2(B[i]);
	  V[2][i]=new QI2(C[i]);
	}
	COUNT=3;
	age=0;
	survey=false;
    }

    public QI2Polygon(QI2[][] A) {
	COUNT=A.length;
	for(int i=0;i<COUNT;++i) {
	  for(int j=0;j<2;++j) {
	    V[i][j]=new QI2(A[i][j]);
	  }
	}
	age=0;
 	survey=false;
    }

    public QI2Polygon(QI2Polygon P) {
	COUNT=P.COUNT;
	for(int i=0;i<COUNT;++i) {
	  for(int j=0;j<2;++j) {
	    V[i][j]=new QI2(P.V[i][j]);
	  }
	}
	age=P.age;
 	survey=P.survey;
	testnumber=P.testnumber;
    }

    /**cyclically reorders*/

    public QI2Polygon rotate() {
	return(this.rotate(1));
    }

    public QI2Polygon rotate(int skip) {
	QI2Polygon P=new QI2Polygon();
	P.COUNT=COUNT;
	for(int i=0;i<COUNT;++i) {
	    for(int j=0;j<2;++j) {
		int k=(i+COUNT+skip)%COUNT;
		P.V[i][j]=new QI2(V[k][j]);
	    }
	}
	P.age=this.age;
	P.survey=this.survey;
	P.testnumber=this.testnumber;
	return(P);
    }




    /**This takes a polygon and returns a union of triangles.  If the
       polygon is convex, the union if is a partition. Otherwise,
       it is a cover.  We only deal with the convex case in practice.*/

    public QI2Polygon[] toSubdivision() {
	QI2Polygon[] LIST=new QI2Polygon[COUNT-2];
	for(int i=0;i<COUNT-2;++i) {
	    LIST[i]=new QI2Polygon(V[0],V[i+1],V[i+2]);
	    LIST[i].survey=survey;
	}

	return(LIST);
    }

    /**drops off the last member of the list*/

    public static QI2Polygon[] truncate(QI2Polygon[] LIST1) {
	int n=LIST1.length; 
	QI2Polygon[] LIST2=new QI2Polygon[n-1];
	for(int i=0;i<n-1;++i) LIST2[i]=new QI2Polygon(LIST1[i]);
	return(LIST2);
    }

    /**copies a list*/
    public static QI2Polygon[] copy(QI2Polygon[] LIST1) {
	int n=LIST1.length; 
	QI2Polygon[] LIST2=new QI2Polygon[n];
	for(int i=0;i<n;++i) LIST2[i]=new QI2Polygon(LIST1[i]);
	return(LIST2);
    }


    /**The rest of these routines are for triangles.*/
    /**drops off the last member and replaces it by the 4
       subdivisions*/


    public static QI2Polygon[] refine(QI2Polygon[] LIST1) {
	int n=LIST1.length; 
	QI2Polygon[] LIST2=new QI2Polygon[n+3];
	for(int i=0;i<n-1;++i) LIST2[i+4]=new QI2Polygon(LIST1[i]);
	QI2Polygon P=LIST1[n-1];
	LIST2[3]=P.shrink00();
	LIST2[2]=P.shrink10();
	LIST2[1]=P.shrink11();
	LIST2[0]=P.shrink01();
	return(LIST2);
    }

    public QI2Polygon shrink00() {
	if(COUNT!=3) return(null);
	QI2[] V0={V[0][0],V[0][1]};
	QI2[] V01=interpolate(V[0],V[1]);
	QI2[] V02=interpolate(V[0],V[2]);
	QI2Polygon W=new QI2Polygon(V0,V01,V02);
	W.age=age+1;
	W.survey=survey;
	W.testnumber=testnumber;
	return(W);
    }

    public QI2Polygon shrink10() {
	if(COUNT!=3) return(null);
	QI2[] V1={V[1][0],V[1][1]};
	QI2[] V01=interpolate(V[0],V[1]);
	QI2[] V12=interpolate(V[1],V[2]);
	QI2Polygon W=new QI2Polygon(V1,V01,V12);
	W.age=age+1;
	W.survey=survey;
	W.testnumber=testnumber;
	return(W);
    }

    public QI2Polygon shrink01() {
	if(COUNT!=3) return(null);
	QI2[] V2={V[2][0],V[2][1]};
	QI2[] V02=interpolate(V[0],V[2]);
	QI2[] V12=interpolate(V[1],V[2]);
	QI2Polygon W=new QI2Polygon(V2,V02,V12);
	W.age=age+1;
	W.survey=survey;
	W.testnumber=testnumber;
	return(W);
    }

    public QI2Polygon shrink11() {
	if(COUNT!=3) return(null);
	QI2[] V01=interpolate(V[0],V[1]);
	QI2[] V02=interpolate(V[0],V[2]);
	QI2[] V12=interpolate(V[1],V[2]);
	QI2Polygon W=new QI2Polygon(V01,V02,V12);	
	W.age=age+1;
	W.survey=survey;
	W.testnumber=testnumber;
	return(W);
    }





    /**gets a point in the interior of a convex polygon*/

    public QI2[] interiorPoint() {
	QI2[] A01=interpolate(V[0],V[1]);
	QI2[] A12=interpolate(V[1],V[2]);
	QI2[] P=interpolate(A01,A12);
	return(P);
    }

    public static QI2[] interpolate(QI2[] A1,QI2[] A2) {
	QI2 B0=QI2.plus(A1[0],A2[0]);
	QI2 B1=QI2.plus(A1[1],A2[1]);
	B0.EASY=false;
	B1.EASY=false;
	++B0.e;
	++B1.e;
	QI2[] B={B0,B1};
	return(B);
    }


    /**This produces a diamond which surrounds an edge.*/

    public static QI2Polygon diamond(QI2[] A1,QI2[] A2,QI2 Z) {
	QI2Polygon P=new QI2Polygon();
	P.V[0]=tent(A1,A2,Z);
	P.V[1][0]=new QI2(A2[0]);
	P.V[1][1]=new QI2(A2[1]);
	P.V[2]=tent(A1,A2,Z.negate());
	P.V[3][0]=new QI2(A1[0]);
	P.V[3][1]=new QI2(A1[1]);
	P.COUNT=4;
	return(P);
    }



    /**This produces a point which makes a tent out of the edge.
       The closer Z is to 0, the closer the extra point is to
       the midpoint of the edge.*/

    public static QI2[] tent(QI2[] A1,QI2[] A2,QI2 Z) {
	QI2[] B1=interpolate(A1,A2);
	QI2[] B2=new QI2[2];
	B2[0]=QI2.minus(A1[1],A2[1]);
	B2[1]=QI2.minus(A2[0],A1[0]);
	B2[0]=QI2.times(B2[0],Z);
	B2[1]=QI2.times(B2[1],Z);
	QI2[] B3=new QI2[2];
	B3[0]=QI2.plus(B1[0],B2[0]);
	B3[1]=QI2.plus(B1[1],B2[1]);
	return(B3);
    }



    /**Printing routines*/

    public String toStringLaTeX(String A) {
	String S=new String("$$"+A+"=");
	for(int i=0;i<COUNT;++i) {
	    if(V[i][0].EASY==true) {
	      S=S+"(";
	      S=S+V[i][0].toStringLaTeX();
	      S=S+",";
	      S=S+V[i][1].toStringLaTeX();  
              S=S+")";
	    }
	    else {
		double t=V[i][0].toDouble();
	        if(Math.abs(t-6.09)<.1) S=S+"(qq)";
		if(Math.abs(t-1.125)<.1) S=S+"(ss)";
	    }
	}
	S=S+"$$";
	return S;
    }





    /**conversion to doubles*/

    public PolyVector toDouble() {
	PolyVector P=new PolyVector();
	P.count=this.COUNT;
	for(int i=0;i<COUNT;++i) {
	    P.V[i]=new Vector();
	    try{
	       P.V[i].x[0]=V[i][0].toDouble();
	       P.V[i].x[1]=V[i][1].toDouble();
	       P.V[i].x[2]=1;
	    }
	    catch(Exception e) {
		P.V[i].x[0]=0;
		P.V[i].x[1]=0;
		P.V[i].x[2]=1;
	    }
	}
	P.age=age;
	return(P);
    }

}


