import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class RenderJulia implements Runnable {
    Manager M;
    boolean HALT;
    public static Color[] COL={
    new Color(255,255,50),
    new Color(255,220,0),
    new Color(255,180,0),
    new Color(255,130,0),
    new Color(255,40,0),
    new Color(180,0,0),
    new Color(130,0,0), 
    new Color(50,255,255),
    new Color(0,220,255),
    new Color(0,180,255),
    new Color(0,120,255),
    new Color(0,50,255),
    new Color(0,0,220),
    new Color(0,0,190)};

    public RenderJulia() {
	HALT=true;
    }

    public RenderJulia(Manager MM) {
	this.M=MM;
	HALT=true;
    }

    /**Main routine*/
    public void run() {
	int i=0;
	int j=0; 
	HALT=false;
	while(HALT==false) {
	    ++i;
            if(i==600) {
                i=0;++j;
	    }
	    if(j==600) {
		i=0;j=0;
		M.P.repaint();
	    }

	    Complex z=M.P.unTransform(i,j);
	    double[] d1={z.x,z.y};
	    double[] d2=HeatSemigroup.B2(d1);
	    boolean test=inSector(d1);
	    if(M.C.DISPLAY.L[0].on==0) test=false;
	    double t=squareReal(d2);
	    int style=PlotStyle.STYLE;
	    Color C=makeColor(style,test,t);
	    int col=convert(C);

	    M.P.IMAGE.setRGB(i,j,col);  
	}
    }

    public Color[] colorList(boolean test) {
	Color[] C=new Color[7];
	int index=0;
	if(test==true) index=7;
	for(int i=0;i<7;++i) C[i]=COL[index+i];
	return C;
    }


    public static Color blur(Color[] C,double u) {
	double[] t={u,1-u};
	double[] c={0,0,0};
	for(int i=0;i<2;++i) {
	    c[0]=c[0]+t[i]*C[i].getRed();
	    c[1]=c[1]+t[i]*C[i].getGreen();
	    c[2]=c[2]+t[i]*C[i].getBlue();
	}
	int[] cc={(int)(c[0]),(int)(c[1]),(int)(c[2])};
	return new Color(cc[0],cc[1],cc[2]);
    }




  /**Main routine*/
    public void savePix() {
	System.out.print("exporting... ");
	Output OUT=new Output("Output/graph");
	for(int i=0;i<600;++i) {
	    for(int j=0;j<600;++j) {
	    Complex z=M.P.unTransform(i,j);
	    double[] d1={z.x,z.y};
	    double[] d2=HeatSemigroup.B2(d1);
	    boolean test=inSector(d1);
	    if(M.C.DISPLAY.L[0].on==0) test=false;
	    double t=squareReal(d2);
	    int style=PlotStyle.STYLE;
	    Color C=makeColor(style,test,t);
	    OUT.pointWrite(i,j,1,C);
	    }
	}
	System.out.println("done");
    }



    public Color makeColor(int choice,boolean test,double u) {
	Color[] C=colorList(test);
	int u1=(int)(u);
	int u2=(int)(u+1);
	int v1=modifyNumber(u1);
	int v2=modifyNumber(u2);
	double s=dec(u,1);
	if(choice==2) s=1-s;
	if(choice==0) s=.99999;
	Color C1=C[v1];
	Color C2=C[v2];
	Color[] CC={C2,C1};
	return blur(CC,s);
    }

    public static double dec(double t,double k) {
	double t1=t/k;
	double t2=t1-Math.floor(t1);
	double t3=k*t2;
	return t3;
    }

    public int modifyNumber(int n) {
	int n1=n%12;
	if(n1<=6) return n1;
	return 12-n1;
    }



    /**Returns the number of iterates needed to get the
       point into the unit square.*/

    public static int squareNumber(double[] d) {
	int count=0;
	boolean test=false;
	double[] d2={d[0],d[1]};
	while((count<1000)&&(test==false)) {  
	    test=inUnitSquare(d2);
            if(test==true) return(0);
            d2=HeatSemigroup.map(d2);
            test=inUnitSquare(d2);
	    ++count;
	}
	return(count);
    }

    public static boolean inUnitSquare(double[] d) {
	if(d[0]<=0) return(false);
	if(d[0]>=1) return(false);
	if(d[1]<=0) return(false);
	if(d[1]>=1) return(false);
	return(true);
    }


    public static double squareReal(double[] d) {
	int count=0;
	boolean test=false;
	double[] d2={d[0],d[1]};
	while((count<1000)&&(test==false)) {  
	    test=inUnitSquare(d2);
            if(test==true) return(squareValue(d2));
            d2=HeatSemigroup.map(d2);
            test=inUnitSquare(d2);
	    ++count;
	}
	return(count+squareValue(d2));
    }

    public static double squareValue(double[] d) {
	double x=d[0];
	double y=d[1];
	double a=x*y*(1-x)*(1-y)/(1-x*y);
	double b=.5*(5*Math.sqrt(5)-11);
	double t=a/b;
	return t*t;
    }


    /**Gauss fundamental domain*/ 

    public static boolean inSector(double[] x) {
	double phi=(1+Math.sqrt(5))/2;
	if(x[1]>x[0]) return(false);
	if(x[1]<-x[0]/(phi*phi)) return(false);
	if(x[0]>QI.outerBound()) return(false);
	return(true);
    }



    /**Coloring: This converts a list of 3 numbers 
       (redval,blueval,greenval)
       into a single integer.*/

    public static int convert(Color C) {
	int[] a={C.getRed(),C.getGreen(),C.getBlue()};	
        int n=256*256*a[0]+256*a[1]+a[2];
	return(n);
    }

}


