import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class SelectCanvas extends Canvas implements MouseListener,KeyListener {
    Manager M;
    Lever AUTO1,AUTO2,NUMBER1,NUMBER2,WHICH,MODE,COERCE,LOCK;
    SelectIntegerKeyboard[] N=new SelectIntegerKeyboard[4];
    ControlPanel PRE;
    ListenSquare[] INFO=new ListenSquare[10];


     public SelectCanvas() {
	 addMouseListener(this);
	 addKeyListener(this);
	 int mem=0;
	 mem=SelectStyle.WHICH;
	 WHICH=new Lever(20,20,mem,2);  //modify domain or range
	 mem=SelectStyle.AUTO1;
	 AUTO1=new Lever(20,53,mem,2);
	 mem=SelectStyle.NUMBER1;
	 NUMBER1=new Lever(20,86,mem,13);
	 mem=SelectStyle.AUTO2;
	 AUTO2=new Lever(20,119,mem,2);
	 mem=SelectStyle.NUMBER2;
	 NUMBER2=new Lever(20,152,mem,13);
	 mem=SelectStyle.MODE;
	 MODE=new Lever(20,185,mem,2);
	 mem=SelectStyle.COERCE;
	 COERCE=new Lever(20,218,mem,4);
	 mem=SelectStyle.LOCK;
	 LOCK=new Lever(20,251,mem,3);
	 for(int i=0;i<4;++i) {
	    N[i]=new SelectIntegerKeyboard(5+49*i,230,44,15,SelectStyle.N[i]);
	 }
	 setPanels();
	 int[] y={20,53,86,119,152,185,218,251};
	 for(int i=0;i<8;++i) INFO[i]=new ListenSquare(5,y[i],12,12);

     }

    public void setPanels() {  
	 Color[] C0={new Color(150,0,150),Color.white,
         Color.white,Color.white,new Color(180,180,180)};

	 String[] PreString={"fundamental domain",
			     "star domain",
			     "fundamental minus star",
			     "The core container U",
			     "The union piece T (domain)",
                             "preset containers"};
	 int[] PreState={1,1,1,1,1};
         PRE=new ControlPanel(C0,PreString,PreState,5);
    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(new Color(100,0,100));
      g.fillRect(0,0,getWidth(),getHeight());
      drawControls(g);
      drawInstructions(g);
   }

    public void drawControls(Graphics2D g) {
	Color C=new Color(100,0,100);
	String[] S1={"no","yes"};
	String[] S2={"domain","container"};
	String[] S3={"approximation","manual"};
	String[] S4={"snap to existing points",
                     "low denominator",
		     "medium denominator",
		     "high denominator"};
	String[] S5={"none","x","y"};

	WHICH.render(g,"change which piece?",S2,new Color(0,160,0));
	AUTO1.render(g,"new piece changes domain?",S1,Color.blue);
	NUMBER1.render2(g,"number of points to domain:",Color.blue);
	AUTO2.render(g,"new piece changes container?",S1,Color.red);
	NUMBER2.render2(g,"number of points to container:",Color.red);
	MODE.render(g,"select mode",S3,new Color(100,0,150)); 

	if(MODE.val==0) {
            COERCE.render(g,"approximation:",S4,new Color(0,130,0));
            LOCK.render(g,"coordinate lock:",S5,new Color(0,130,0));
	}

	if(MODE.val==1) {
          for(int i=0;i<4;++i) {
	      N[i].render(g,new Color(0,130,0),new Color(0,180,0),Color.white,Color.white);
	  }
	}

	PRE.render(g,5,280,190);
	for(int i=0;i<8;++i) INFO[i].infoRender(g);

    }


    public void drawInstructions(Graphics2D g) {

        g.drawString("Turn on the polygon display, then click",7,425);
        g.drawString("(middle button) on some partition piece",7,440);
        g.drawString("to activate the polygon display",7,455);
        g.drawString("keys 123456789abc move point",7,470);
        g.drawString("keys +- cycle vertices",7,485);

    }


    /**This deals with the presets*/


    public void doPresetContainer(Point X) {
	int k=PRE.getValue(X);

	if((k>=0&&k<3)) {
	   M.P.RANGE=DataPartitionManager.piece(50+k);
	   int q=M.P.RANGE.COUNT;
	   SelectStyle.NUMBER2=q;
	   NUMBER2.val=q;
	   WHICH.val=1;
	 }

	if(k==3) {
	   M.P.RANGE=DataConfiner.mainRaw(4);
	   int q=M.P.RANGE.COUNT;
	   SelectStyle.NUMBER2=q;
	   NUMBER2.val=q;
	   WHICH.val=1;
	 }

	if(k==4) {
	   M.P.DOMAIN=DataPartitionManager.piece(53);
	   int q=M.P.DOMAIN.COUNT;
	   SelectStyle.NUMBER1=q;
	   NUMBER1.val=q;
	   WHICH.val=0;
	 }
    }


    public void documentStuff(Point X) {
	if(INFO[0].inside(X)==1) DocumentPoly.polyToggle(M);
	if(INFO[1].inside(X)==1) DocumentPoly.domainToggle(M);
	if(INFO[2].inside(X)==1) DocumentPoly.domainNumber(M);
	if(INFO[3].inside(X)==1) DocumentPoly.containerToggle(M);
	if(INFO[4].inside(X)==1) DocumentPoly.containerNumber(M);
	if(INFO[5].inside(X)==1) DocumentPoly.selectMode(M);
	if(INFO[6].inside(X)==1) DocumentPoly.coerceInfo(M);
	if(INFO[7].inside(X)==1) DocumentPoly.coordLock(M);
	int d=PRE.switchMode(X);
	if(d==99) DocumentPoly.polyPreset(M); 

    }




    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	int d=0;
	WHICH.process(J.X);
	AUTO1.process(J.X);
	AUTO2.process(J.X);
	NUMBER1.process(J.X);
	NUMBER2.process(J.X);
	MODE.process(J.X);
	if(MODE.val==0) {
           COERCE.process(J.X);
           LOCK.process(J.X);
	}
	if(MODE.val==1) {
	    int index=-1;
	    for(int i=0;i<4;++i) {
		if(N[i].inside(J.X)==1) index=i;
	    }
	    if(index!=-1) {
		for(int i=0;i<4;++i) N[i].on=0;
		N[index].on=1;
	    }
	}

	SelectStyle.WHICH=WHICH.val;
	SelectStyle.MODE=MODE.val;
	SelectStyle.AUTO1=AUTO1.val;
	SelectStyle.AUTO2=AUTO2.val;
	SelectStyle.NUMBER1=NUMBER1.val;
	SelectStyle.NUMBER2=NUMBER2.val;
	if(WHICH.val==0) M.P.DOMAIN.COUNT=NUMBER1.val;
	if(WHICH.val==1) M.P.RANGE.COUNT=NUMBER2.val;
	SelectStyle.MODE=MODE.val;
	SelectStyle.COERCE=COERCE.val;
	SelectStyle.LOCK=LOCK.val;
	doPresetContainer(J.X);
	documentStuff(J.X);
	M.repaint();
    }

    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {
	requestFocus();
    }
    public void mouseExited(MouseEvent e) {}   
    public void keyPressed(KeyEvent e) {}

    public void keyTyped(KeyEvent e) {
	for(int i=0;i<4;++i) {
	    if(N[i].on==1) N[i].modify(e);
	    SelectStyle.N[i]=N[i].sign*N[i].val;
	}
	M.repaint();
    }

    public void keyReleased(KeyEvent e) {}




}

