import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class TestCanvas extends ScaleCanvas implements MouseListener {
    Manager M;
    QITestWrapper QIT;
    ControlPanelColor TEST;
    ControlPanel STRICT;
    ListenSquare GO,STOP,RESET;
    HandleTestArea HTA;
    HandleTestNorm HTN;
    HandleTestCone HTC;
    HandleTestStretch HTS;
    MonitorTests MT;
    boolean FAIL;
    String[] FAIL_MESSAGE=new String[2];

     public TestCanvas() {
	 addMouseListener(this);
	 GO=new ListenSquare(320,5,30,20,null);GO.on=1;
	 STOP=new ListenSquare(320,25,40,20,null);STOP.on=1;
	 RESET=new ListenSquare(320,45,40,20,null);RESET.on=1;
	 QIT=new QITestWrapper();
	 HTC=new HandleTestCone(113,72);
	 HTS=new HandleTestStretch(113,72);
	 HTA=new HandleTestArea(113,72);
	 HTN=new HandleTestNorm(113,72);
	 MT=new MonitorTests();
	 FAIL_MESSAGE[0]="";
	 FAIL_MESSAGE[1]="";
	 FAIL=false;
	 setPanels();
     }



    public void setPanels() {  

	Color[] C0={new Color(0,100,100),Color.white,
         Color.white,Color.white,new Color(180,180,180)};
	Color C=new Color(255,0,255);
	Color[] C1={C,C,C,C,C,C,C,C,C};

 	 String[] TestString={"denom","confine","exclude",
                              "area","L2 norm","cone","stretch","calcs"};
	 int[] TestState={1,0,0,0,0,0,0};
         TEST=new ControlPanelColor(C0,TestString,TestState,7,C1);
	 TEST.mode=0;

 	 String[] StrictString={"weak (WPDA)","strong (PDA)","weak special","test mode"};
	 int[] StrictState={1,0,0};
         STRICT=new ControlPanel(C0,StrictString,StrictState,3);
	 STRICT.mode=0;

    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);	
   }

   public void drawBG(Graphics2D g) {
       g.setColor(new Color(50,100,255));
        g.fillRect(0,0,getWidth(),getHeight()); 
	g.setColor(Color.white); 
        g.drawRect(0,0,getWidth()-1,getHeight()-1); 
   }

    public void drawControls(Graphics2D g) {
	int m=TEST.mode;
	TEST.render(g,4,5,105);
	STRICT.render(g,4,135,105);
	if(m==3) HTA.render(g);
	if(m==4) HTN.render(g);
	if(m==5) HTC.render(g);
	if(m==6) HTS.render(g);
	drawGo(g);
	if(FAIL==false) MT.render(g);
	if(FAIL==true) {
	    g.setColor(Color.white);
            g.setFont(new Font("Helvetica",Font.PLAIN,15));
	    g.drawString(FAIL_MESSAGE[0],120,20);
	    g.drawString(FAIL_MESSAGE[1],120,40);
	}
	RESET.render(g,"reset",12,3,Color.blue);
    }



    /**These routines are the ones which control the
       auxiliary running threads in the program - i.e.
       all the tests*/
   

    public void doAction(Point X) {
	if(GO.inside(X)==1) go();
	if(STOP.inside(X)==1) doStop();
    }

    public void drawGo(Graphics2D g) {
	if(QIT.HALT==true) GO.render(g,"go",12,3,new Color(0,180,0));
	else {STOP.render(g,"stop",12,3,new Color(250,0,0));}
    }

    /**This is the basic go-button switch*/
    public boolean go() {
	if(QIT.HALT==false) return(false);
	QIT=new QITestWrapper(this.M);
        new Thread(QIT).start();
	return(true);
    }

    /**stops everything*/
    public void doStop() {
	QIT.HALT=true;
    }
    /**End of thread controls*/


    /**These routines let you specify which tests
       are performed.*/

    public void setTestValues(Point X) { 
        int d=STRICT.switchMode(X);
	if(d==99) DocumentTests.strictInfo(this.M);
	if(TEST.mode==3) d=HTA.process(X);
	if(TEST.mode==4) d=HTN.process(X);
	if(TEST.mode==5) d=HTC.process(X);  
	if(TEST.mode==6) d=HTS.process(X);  
    }


    public void setTest(Point X) {
        int d=TEST.switchMode(X);
	if(d==99) DocumentTests.testInfo(this.M);
	if(d==0) DocumentTests.denomInfo(this.M);
	if(d==1) DocumentTests.confinerInfo(this.M);
	if(d==2) DocumentTests.excluderInfo(this.M);
	if(d==3) DocumentTests.areaInfo(this.M);
	if(d==4) DocumentTests.expandInfo(this.M);
	if(d==5) DocumentTests.coneInfo(this.M);
	if(d==6) DocumentTests.stretchInfo(this.M);
    }
    /**End of test modifiers*/


    /**This clears the triangular pieces off the main window*/

    public void reset() {
	M.P.TR.COUNT=0;
	M.P.TR.INDEX=-1;
	if(QIT.HALT==true) MT.STATE=-1;
    }

    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);	
	doAction(J.X);
	setTest(J.X);
	setTestValues(J.X);
	M.repaint();
	if(RESET.inside(J.X)==1) reset();
    }

     public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


}

