import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class TileCanvas extends Canvas implements MouseListener,KeyListener {
    Manager M;
    HandleTile HT;
    Lever SUB,FILL;
    ListenSquare PRINT; 
    String MONO; 
    ListenSquare ASSIGN;

     public TileCanvas() {
	 addMouseListener(this);
	 addKeyListener(this);
         HT=new HandleTile(87,65);
         HT.forceBox(SelectPartition.TILE);
	 int mem=0;
	 mem=SelectPartition.FILL;
	 FILL=new Lever(5,18,mem,2);
	 mem=SelectPartition.SUB;
	 SUB=new Lever(5,50,mem,2);
	 PRINT=new ListenSquare(105,223,65,28);
	 MONO="";
	 ASSIGN=new ListenSquare(5,223,20,20);
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);


      drawBackground(g);
      drawControls(g);
      drawAlphabet(g);
   }

    public void drawBackground(Graphics2D g) {
	g.setColor(new Color(120,120,120));
	g.fillRect(0,0,getWidth(),getHeight());
	g.setColor(Color.white);
	g.drawRect(0,0,getWidth()-1,getHeight()-1);
    }
    public void drawControls(Graphics2D g) {
	HT.render(g);
	String[] S={"no","yes"};
	SUB.render(g,"subdivide? ",S,Color.red);
	FILL.render(g,"fill plot? ",S,Color.red);
	PRINT.render(g,Color.blue);
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,11));
	g.drawString("print",110,234);
	g.drawString("coords",110,249);
    }

    public void drawAlphabet(Graphics2D g) {
	String S=recognizeTile();
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.drawString(S,110,23);
	g.drawString(MONO,30,240);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString("select piece (A,B,I1,...)",5,200);
	g.drawString("using the keyboard.",5,215);
	ASSIGN.render(g,Color.yellow);

    }

    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	int d=HT.process(J.X,this.M);
	SUB.process(J.X);
	FILL.process(J.X);
	SelectPartition.SUB=SUB.val;
	SelectPartition.FILL=FILL.val;
	if(ASSIGN.inside(J.X)==1) assignPiece();
	if(PRINT.inside(J.X)==1) print();
	M.repaint();
    }

    public void print() {
	int n=SelectPartition.TILE;
	QI2Polygon P=DataPartitionManager.piece(n);
	String S1=recognizeTile();
	String S=P.toStringLaTeX(S1);
	System.out.println(S);
    }



    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}   
    public void mouseMoved(MouseEvent e) {}    
    public void mouseDragged(MouseEvent e) {}
    public void keyPressed(KeyEvent e) {}
    public void keyTyped(KeyEvent e) {
	int n=MONO.length();
	char ch=e.getKeyChar();

        if (ch==KeyEvent.VK_BACK_SPACE) {
	    if(n>0) MONO=MONO.substring(0,n-1);
        }
        else {MONO=MONO+ch;}
	repaint();
    }



    public boolean isDigit(char ch) {
        int val=(int)(ch-'0');
        if ((val>=0)&&(val<=9)) {
	    return(true);
	}
	return(false);
    }

    public void keyReleased(KeyEvent e) {}



    /**Monograph data*/

    public String recognizeTile() {
	int n=SelectPartition.TILE;
	return(recognizeTile(n));
    }

    public static String recognizeTile(int n) {
	if(n==0) return("R");
	if(n==1) return("T1");
	if(n==2) return("T2");
	if(n==3) return("T3");
	if(n==4) return("N");
	if(n==5) return("O");
	if(n==17) return("F");
	if(n==40) return("S1");
	if(n==22) return("S2");
	if(n==29) return("S3");

	if(n==30) return("I1");
	if(n==25) return("I2");
	if(n==18) return("I3");
	if(n==14) return("I4");

	if(n==12) return("P11");
	if(n==10) return("P12");
	if(n==8) return("P13");
	if(n==6) return("P14");

	if(n==13) return("P21");
	if(n==11) return("P22");
	if(n==9) return("P23");
	if(n==7) return("P24");

	if(n==27) return("K1");
	if(n==21) return("K2");
	if(n==26) return("L1");
	if(n==20) return("L2");

	if(n==28) return("J1");
	if(n==24) return("J2");
	if(n==15) return("J31");
	if(n==16) return("J32");
	if(n==23) return("J4");

	if(n==32) return("E");
	if(n==33) return("T4");
	if(n==34) return("B&C");
	if(n==37) return("M");
	if(n==38) return("T5");
	if(n==39) return("U");

	if(n==35) return("A");
	if(n==36) return("D");
	if(n==19) return("G");
	if(n==31) return("H");

	if(n==48) return("S12");
	if(n==45) return("S17");
	if(n==44) return("S15");
	if(n==43) return("S13");
	if(n==42) return("S14");
	if(n==46) return("S16");;
	if(n==47) return("Y");;
	if(n==41) return("S11");
	return("?");

    }


    public void assignPiece() {
	int t=-1;
	if(MONO.equals("R")==true) t=0;
	if(MONO.equals("S1")==true) t=40;
	if(MONO.equals("S2")==true) t=22;
	if(MONO.equals("S3")==true) t=29;
	if(MONO.equals("T1")==true) t=1;
	if(MONO.equals("T2")==true) t=2;
	if(MONO.equals("T3")==true) t=3;
	if(MONO.equals("T4")==true) t=33;
	if(MONO.equals("T5")==true) t=38;

	if(MONO.equals("A")==true) t=35;
	if(MONO.equals("B")==true) t=34;
	if(MONO.equals("C")==true) t=34;
	if(MONO.equals("BC")==true) t=34;
	if(MONO.equals("B&C")==true) t=34;
	if(MONO.equals("D")==true) t=36;

	if(MONO.equals("E")==true) t=32;
	if(MONO.equals("F")==true) t=17;
	if(MONO.equals("G")==true) t=19;
	if(MONO.equals("H")==true) t=35;

	if(MONO.equals("I1")==true) t=30;
	if(MONO.equals("I2")==true) t=25;
	if(MONO.equals("I3")==true) t=18;
	if(MONO.equals("I4")==true) t=14;

	if(MONO.equals("J1")==true) t=28;
	if(MONO.equals("J2")==true) t=24;
	if(MONO.equals("J31")==true) t=15;
	if(MONO.equals("J32")==true) t=16;
	if(MONO.equals("J4")==true) t=23;

	if(MONO.equals("K1")==true) t=27;
	if(MONO.equals("K2")==true) t=21;
	if(MONO.equals("L1")==true) t=26;
	if(MONO.equals("L2")==true) t=20;

	if(MONO.equals("P11")==true) t=12;
	if(MONO.equals("P12")==true) t=10;
	if(MONO.equals("P13")==true) t=8;
	if(MONO.equals("P14")==true) t=6;

	if(MONO.equals("P21")==true) t=13;
	if(MONO.equals("P22")==true) t=11;
	if(MONO.equals("P23")==true) t=9;
	if(MONO.equals("P24")==true) t=7;

	if(MONO.equals("M")==true) t=37;
	if(MONO.equals("N")==true) t=4;
	if(MONO.equals("O")==true) t=5;

	if(MONO.equals("S12")==true) t=48;
	if(MONO.equals("S17")==true) t=45;
	if(MONO.equals("S15")==true) t=44;
	if(MONO.equals("S13")==true) t=43;
	if(MONO.equals("S14")==true) t=42;
	if(MONO.equals("S16")==true) t=46;
	if(MONO.equals("S11")==true) t=41;

	if(MONO.equals("Y")==true) t=47;
	if(MONO.equals("U")==true) t=39;

	if(t!=-1) {
	    HT.setPiece(t,M);
	    SelectPartition.TILE=t;
	}
	M.repaint();
    }



}

